<template>
  <div class="upload-payroll">
    <button class="btn btn-primary" @click="showCloseForm">Nueva Nomina</button>

    <form
      class="upload-payroll__form"
      :class="{ open: showForm }"
      @submit.prevent="handleSubmit"
    >
      <div class="field">
        <label for="file">
          <i class="file icon"></i>Selecionar nomina
          <span v-if="file">{{ file.name }}</span>
        </label>
        <input
          type="file"
          id="file"
          style="display: none"
          @change="uploadFile"
          :value="date"
        />
      </div>
      <br />
      <div class="field">
        <label for="start">Fecha: </label>
        <input
          class="fecha"
          type="date"
          id="start"
          name="trip-start"
          @change="changeDate"
        />
      </div>
      <br />
      <button class="btn btn-primary">Subir Nomina</button>
      <p v-if="error">{{ error }}</p>
    </form>
  </div>
</template>

<script>
import { ref } from "vue";
import { v4 as uuidv4 } from "uuid";
import { storeFile } from "../../utils/firebase";

export default {
  name: "UploadPayroll",

  setup() {
    let showForm = ref(false);
    let file = ref(null);
    let date = ref(null);
    let error = ref(null);

    const showCloseForm = () => {
      showForm.value = !showForm.value;
    };

    const changeDate = (e) => {
      date.value = e.target.value;
    };

    const uploadFile = (e) => {
      const fileTemp = e.target.files[0];
      error.value = null;

      if (fileTemp.type === "application/pdf") {
        file.value = fileTemp;
      } else {
        error.value = "Fichero no valido";
      }
    };

    const handleSubmit = async () => {
      if (file.value && date.value) {
        try {
          const nameFile = uuidv4();
          await storeFile(nameFile, file.value);
          console.log("TODO Ok");
          /*await storage
            .ref(Auth.currentUser.uid)
            .child(`${nameFile}.pdf`)
            .put(file.value);*/
        } catch (error) {
          console.log(error);
        }
      }
    };

    return {
      showForm,
      showCloseForm,
      handleSubmit,
      uploadFile,
      changeDate,
      error,
      date,
      file,
    };
  },
};
</script>

<style lang="scss" scoped>
.upload-payroll {
  &__form {
    display: flex;
    align-items: center;
    flex-direction: column;
    height: 0;
    overflow: hidden;
    transition: height 0.3s ease;

    &.open {
      height: 200px;
    }
  }
}
button {
  margin-bottom: 20px;
}

label {
  background: rgb(213, 219, 216);
}
button:hover {
  background-color: #3ab025;
}
</style>
